// cave.idc : An IDA IDC script to find alignment blocks
// (also called 'cave') in an IDA database.
// Useful when you need to add code to a binary file
// Say for example you found an exploitable bug in a program
// and you don't want to wait for the developer to provide a bugfix,
// you can add your own code to the alignment block in order to manually
// fix the bug.

// Code by trapflag
// bugfixed by death


#include <idc.idc>

static main()
{
	auto ea,cont,x,nBlocks, nSize, nMinSize, sUser, nUser;

	Message("\ncave.idc v1.02 by trapflag\n--------------------------\n");
	Message("Waiting for auto-analysis to finish... ");
	Wait();
	Message("ok.\n\n");
	
	sUser = AskStr("0","Enter minimum size (in bytes) of alignment blocks to find");
	
	if( sUser == 0)
	{
		Message("Cancelled.\n");
		return;
	}

	nMinSize = atol(sUser);
	ea = FirstSeg();
	cont = 1;
	x = 0;
	nUser = 0;
	
	Message("Possible alignment block(s):\n");
	while (cont==1)
	{
		ea = FindText(ea,SEARCH_DOWN, 0, 0, "align ");
		if (ea == x)
		{
			cont = -1;
			break;
		}
		x = ea;
		if( ea == -1)
		{
			Message("No more hits");
			break;
		}
		nBlocks++;
        nSize = ItemSize(ea);

	if(nSize >= nMinSize)
	{
		nUser++;
        	Message("%s %ld alignment bytes\n", atoa(ea), nSize);
        }
        ea = ea + nSize;
	}
	Message("\n%ld out of %ld total alignment blocks have been found.\n", nUser, nBlocks);
}
